require 'context'

def print_context(c)
    print "#{c.hash1}\t"
    print (c.typewriter	? 'B' : ' ')
    print (c.italic		? 'B' : ' ')
    print (c.strong_emphasis ? 'B' : ' ')
    print (c.emphasis	? 'B' : ' ')
    print (c.bold		? 'B' : ' ')
    print (c.underline)
    print "\n"
end

Boolean = [true,false]
Underline = (0..3)

ary = []
Boolean.each do |typewriter|
    Boolean.each do |italic|
	Boolean.each do |strong_emphasis|
	    Boolean.each do |emphasis|
		Boolean.each do |bold|
		    Underline.each do |underline|
			c = Context.new
			
			c.bold = bold
			c.typewriter = typewriter
			c.italic = italic
			c.emphasis = emphasis
			c.strong_emphasis = strong_emphasis
			c.instance_eval {
			    _set_underline underline
			}
			#print_context(c)
			ary << c
		    end
		end
	    end
	end
    end
end

# p ary.size
# p ary.map{|c| c.hash1}.uniq.size

# print "----------------------------\n"

# ary_sorted = ary.sort{|c1,c2| c1.hash1 <=> c2.hash1 }
# ary_sorted.each do |c|
#     print_context c
# end

ary_sorted = ary.sort{|c1,c2| c1.hash1 <=> c2.hash1 }

if ary_sorted.size != ary_sorted.uniq.size
    raise "hash1 not unique!!!"
end

map_values =
    [true,false].map { |pl_both|
    ary_sorted.map { |from|
	ary_sorted.map { |to|
	    from.distance_min_est_tag_1(to,pl_both)
	}.uniq
    }
}.flatten.uniq.sort

print "map_values: "
p map_values

File.open("context_sub.rb","w") do |f|
    f.print "# automatically generated.\n"
    f.print "# require 'context'\n"
    f.print "\n"
    f.print "require 'context_sub/context_sub_impl.so'\n"
    f.print "#require File.join(File.dirname(__FILE__),'context_sub_impl.so')\n"
    f.print "\n"
    f.print "class Context\n"
    f.print "    DIST_MAP_VALUES = [\n"
    f.print "        "+map_values.map{|val| val.to_s}.join(', ')+"\n"
    f.print "    ].freeze\n"
    f.print "    def self.distance_min_est_tag_1(c1,c2,pl_both)\n"
    f.print "        index = distance_min_est_tag_1_index(c1,c2,pl_both)\n"
    f.print "        DIST_MAP_VALUES[index]\n"
    f.print "    end\n"
    f.print "    alias distance_min_est_tag_1_orig distance_min_est_tag_1\n"
    f.print "    def distance_min_est_tag_1_fast(other,pl_both)\n"
    f.print "        Context.distance_min_est_tag_1(self,other,pl_both)\n"
    f.print "    end\n"
    f.print "    alias distance_min_est_tag_1 distance_min_est_tag_1_fast\n"
    f.print "end\n"
    f.print "\n"
    f.print "# end of file.\n"
end

File.open("distance_min_est_tag_1.h","w") do |f|
    f.print "/* table definition for distance_min_est_tag_1 */\n"
    f.print "/* automatically generated. */\n"
    [true,false].each do |pl_both|
	f.print "\n"
	f.print "static const int distance_min_est_tag_1_#{pl_both}_table"
	f.print "[#{ary_sorted.size}][#{ary_sorted.size}] = {\n"
	f.print ary_sorted.map { |from|
	    ary_sorted.map { |to|
		d = from.distance_min_est_tag_1(to,pl_both)
		map_values.index(d).to_s
	    }.join(', ')
	}.join(",\n")
	f.print "\n"
	f.print "};\n"
    end
    f.print "/* end of file. */\n"
end
